#include <QPointF>
#include <QList>

class QPaintEvent;
class QTabletEvent;

class EventHandler {
public:
    EventHandler();
    void handleTabletEvent( QTabletEvent *event );

    QPointF brushPosition() const { return m_brushPosition; }
    QList<QPointF> endPoints() const { return m_brushEndPoints; }

private:
    void initBrush(qreal pressure);
    double angleFromDistance(const QPointF &point);

    // these are the visualisation points.
    QPointF m_brushPosition;
    QList<QPointF> m_brushEndPoints;

    // the data structure to remember how we got here
    //double m_brushAngle; //  in rad, 1/2 PI == perpendicular to medium
    //double m_brushRotation;   // in rad. 0 is horizontal brush
    double m_hairDirection;   // in rad 0 is to the left
    double m_contactAreaRadius; // in pt defining the length of the hairs that touches the medium

    const double m_maxBrushLength; // just make it const for now...
    const double m_defaultBrushWidth; // the biggest width of the brush.  Just make it const for now.
    QList<QPointF> m_lastPositions;
};

