#include <QtGui>

#include "EventHandler.h"

int main (int a, char **c) {
    QApplication app(a,c);

    class MyWidget : public QWidget {
      public:
        MyWidget(EventHandler *eventHandler) :m_eventHandler(eventHandler) {
            setFocusPolicy(Qt::StrongFocus);
            setMouseTracking( true );
            setCursor(Qt::BlankCursor);
        }
        virtual void paintEvent( QPaintEvent *e ) {
            QPainter painter( this );
            painter.setPen(QPen(Qt::red));
            QPoint brushPosition = mapFromGlobal(m_eventHandler->brushPosition().toPoint());
            painter.drawLine(QPointF(brushPosition.x() -5, brushPosition.y()), QPointF(brushPosition.x() +5, brushPosition.y()));
            painter.drawLine(QPointF(brushPosition.x(), brushPosition.y() -5), QPointF(brushPosition.x(), brushPosition.y() +5));
            painter.setPen(QPen(Qt::gray));

            foreach(QPointF point, m_eventHandler->endPoints()) {
                painter.drawLine(brushPosition, mapFromGlobal(point.toPoint()));
            }
            painter.end();
        }

        virtual void tabletEvent( QTabletEvent *e ) {
            m_eventHandler->handleTabletEvent(e);
            e->accept();
            update();
        }

        EventHandler *m_eventHandler;
    };

    QMainWindow mw;
    mw.setCentralWidget(new MyWidget(new EventHandler()));
    mw.setMinimumSize(QSize(800,600));
    mw.show();

    return app.exec();
}
